import octofuss
from twisted.internet import reactor
from twisted.python import threadable; threadable.init(1)
import urllib
from xml.etree import ElementTree as ET
import os, os.path

from twisted.internet.threads import deferToThread
import sys

_ = lambda x:x
mydeferred = deferToThread.__get__


class Tweets(octofuss.Tree):
    def __init__(self, name = None):
        super(Tweets, self).__init__(name, doc="Read-only contents for net tweets")
        self.update_status()
        self._tweets = []

    def update_status(self):
        try:
            data = urllib.urlopen("http://identi.ca/api/statuses/user_timeline/fuss.xml").read()
        except:
            return
        element = ET.XML(data)
        self._tweets = []
        interesting = ['text', 'created_at']
        for s in element:
            post = {}
            for sub in s:
                if sub.tag in interesting:
                    post[sub.tag] = sub.text
            self._tweets.append(post)

    
    def llist(self, path):

        if not path:
            return range(len(self._tweets))
        else:
            try:
                return self._tweets[int(path[0])]
            except Exception, e:
                return {}

    def lget(self, path):
        return self.llist(path)

def init(**kw):
    tree = kw.get("tree", None)
    conf = kw.get("conf", None)

    tweets = Tweets("tweets")

    @mydeferred
    def update_all_data():

        tweets.update_status();
        reactor.callLater(60, update_all_data)

    reactor.callLater(1, update_all_data)

    yield dict(tree = tweets, root = "/")

