import octofuss
from octofussd.model import Users
import os, os.path
from gettext import gettext as _

# Plugin implementation
class UserLog(octofuss.PyTree):
    def __init__(self, name = None):
        super(UserLog, self).__init__(name, doc="Log of changes to the user database")

    def _get(self):
        return None

    def _lastinterval(self, interval):
        res = Users.select("timestamp > datetime('now', '-1 %s')" % interval).orderBy("-timestamp")
        return [(x.timestamp.isoformat(" "), x.username, x.action) for x in res]

    lastyear = property(lambda x:x._lastinterval("year"), doc="Last year of changes")
    lastmonth = property(lambda x:x._lastinterval("month"), doc="Last month of changes")
    lastday = property(lambda x:x._lastinterval("day"), doc="Last day of changes")
    lasthour = property(lambda x:x._lastinterval("hour"), doc="Last hour of changes")
    lastminute = property(lambda x:x._lastinterval("minute"), doc="Last minute of changes")

def init(**kw):
    yield dict(
            tree = UserLog("userlog"),
            root = "/"
            )
